﻿using C1.FlexPivot;
using C1.FlexPivot.Internal;
using C1.Win.FlexPivot;
using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace CubeDataAnalysis
{
     public partial class Form1 : Form
     {
          public Form1()
          {
            InitializeComponent();

            string connectionString = @"Data Source=http://ssrs.componentone.com/OLAP/msmdpump.dll;Provider=msolap;Initial Catalog=AdventureWorksDW2012Multidimensional";
            string cubeName = "Adventure Works";
            c1FlexPivotPage1.FlexPivotPanel.ConnectCube(cubeName, connectionString);

            //Show KPI Field data in the FlexPivotPage using ValueFields
            var fp = c1FlexPivotPage1.FlexPivotEngine;
            fp.BeginUpdate();
            fp.ColumnFields.Add("Date.Fiscal Year");
            fp.RowFields.Add("Category");
            fp.ValueFields.Add("Internet Revenue Trend");
            fp.ValueFields.Add("Internet Revenue Status");
            fp.EndUpdate();

            KpiGraphicsCombo.DataSource = Enum.GetValues(typeof(KpiGraphics));
            KpiGraphicsCombo.SelectedIndex = 6;
            KpiGraphicsCombo.SelectedIndexChanged += KpiGraphicsComboBox_SelectedIndexChanged;
          }
          private void KpiGraphicsComboBox_SelectedIndexChanged(object sender, EventArgs e)
          {
               Scan(c1FlexPivotPage1.FlexPivotEngine.Fields);
          }
          void Scan(IEnumerable<C1FlexPivotField> list)
          {
              foreach (var field in list)
              {
                  if (field is C1KpiField)
                      (field as C1KpiField).KpiGraphics = (KpiGraphics)Enum.Parse(typeof(KpiGraphics), KpiGraphicsCombo.SelectedValue.ToString());
                  if (field is C1CubeField)
                      Scan((field as C1CubeField).SubFields);
              }
          }
    }
}
